jQuery(document).ready( function () {
	mmmdt_load_table_from_api(); 
} );
function mmmdt_load_table_from_api(){
	(function($, undefined) { 
		jQuery(document).ready(function() {
			jQuery('#mmmdt_result_section').show();
			//create a new button instance:
			//ما دکمه رفرش رو پایینتر  موقع ایجاد جدول در کنار بقیه دکمه ها میگزاریم
			$.fn.dataTable.ext.buttons.refresh = {
				text: 'رفرش',
				className: 'mmmdt_refresh_button',
			    action: function ( e, dt, node, config ) {
				  dt.clear().draw();
				  dt.ajax.reload();
				}
			};
			if( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) ) {}else{
				// Setup - add a text input to each footer cell
				$('#mmmdt_all_data_result_table thead th').each( function () {
					var title = $(this).text();
					var this_html = $(this).html();
					$(this).html( this_html +'<input type="text" style="width: 120px; display: block; margin-top: 4px;" placeholder="جستجو" />' );
				} );
			}
			//نام دسته بندی رو از اسلاگ برگه می گیریم
			//هر جا که شرت کات قرار بگیره نام اسلاگ  دایرکتوری رو به عنوان دسته می فرسته برای ای پی آی تا لیست بگیره
			var url_location = window.location.pathname;
			var url_dir = url_location.substring(0, url_location.lastIndexOf('/'));
			var category = url_dir.replace(/\\|\//g,'');
			//jQuery('#mmmdt_loading_ajax_result_table').show();//خود جدول علامت بارگزاری ای جکس داره
			var car_table = $('#mmmdt_all_data_result_table').DataTable( {
				//dom: "Bfrtip",
				dom: 'Blfrtip',
				ajax: mmmdt_this_site_url + '/wp-json/mmmdt/get_all_records?cat=' + category,
				columns: [
					/*
					{ data: null, render: function ( data, type, row ) {
						// Combine the first and last names into a single table field
						//return data.first_name+' '+data.last_name;
						return data.id;
					} },
					*/
					{ data: "id" ,type: "readonly","visible": false},
					{ data: "type" ,type: "readonly","visible": false},
					{ data: "vaziayat" ,type: "readonly","visible": false},
					{ data: "category" ,type: "readonly","visible": false},
					{ data: "title" ,type: "readonly","width": "10%"},
					{ data: "contact" ,type: "readonly","width": "20%"},
					{ data: "relation" ,type: "readonly","width": "25%"},
					{ data: "tovlid" ,type: "readonly","width": "15%"},
					{ data: "masraf" ,type: "readonly","width": "15%"},
					{ data: "address" ,type: "readonly","width": "15%"},
					//{ data: "mmmdt_model_name" ,type: "readonly"},
					//{ data: "mmmdt_tip_name" ,type: "readonly"},
					//{ data: "mmmdt_official_name" },
					//{ data: "mmmdt_official_price", render: $.fn.dataTable.render.number( ',', '.', 0, '' ) }
				],
				//select: true,
				select: 'single',
				altEditor: true,
				"responsive": true,
				"order": [[ 0, "desc" ]],
				"pageLength": 10,
				"lengthChange": true,
				
				"lengthMenu": [[10, 25, 50,100,200, -1], [10, 25, 50,100,200, "همه"]],
				"processing": true,
				"fnInitComplete": function(oSettings, json) {
					//console.log(json);
					//jQuery('#mmmdt_result_section').show();
					//jQuery('#mmmdt_loading_ajax_result_table').hide();

				},
				//https://stackoverflow.com/questions/46444828/filter-datatable-column-using-dropdown
				initComplete: function() {
				  //ریست فیلتر
				  var $resetButton =
				  $( '<span class="posts-table-reset"><a class="reset" href="#"> ریست </a></span>' )
				  .on( 'click', 'a', function(){
					  event.preventDefault();
					  reset_all_data();
				  });
				  $resetButton.appendTo("#mmmdt_selectTriggerFilter");
				  //فیلتر نوع
				  var column = this.api().column(1);
				  var select = $('<select id="mmmdt_all_data_table_type_select" class="filter"><option value="" selected > نوع </option></select>')
					.appendTo('#mmmdt_selectTriggerFilter')
					.on('change', function() {
					  var val = $(this).val();
					  column.search(val ? '^' + $(this).val() + '$' : val, true, false).draw();
					});
				  column.data().unique().sort().each(function(d, j) {
					select.append('<option value="' + d + '">' + d + '</option>');
				  });
				  jQuery("#mmmdt_all_data_table_type_select option:contains('null')").remove();
				  //فیلتر وضعیت
				  var vaziayat_column = this.api().column(2);
				  var select = $('<select id="mmmdt_all_data_table_vaziayat_select" class="filter"><option value="" selected > وضعیت </option></select>')
					.appendTo('#mmmdt_selectTriggerFilter')
					.on('change', function() {
					  var val = $(this).val();
					  vaziayat_column.search(val ? '^' + $(this).val() + '$' : val, true, false).draw();
					});
				  vaziayat_column.data().unique().sort().each(function(d, j) {
					select.append('<option value="' + d + '">' + d + '</option>');
				  });
				  jQuery("#mmmdt_all_data_table_vaziayat_select option:contains('null')").remove();
				  //فیلتر دسته بندی
				  var category_column = this.api().column(3);
				  var select = $('<select id="mmmdt_all_data_table_category_select" class="filter"><option value="" selected > دسته </option></select>')
					.appendTo('#mmmdt_selectTriggerFilter')
					.on('change', function() {
					  var val = $(this).val();
					  category_column.search(val ? '^' + $(this).val() + '$' : val, true, false).draw();
					});
				  category_column.data().unique().sort().each(function(d, j) {
					select.append('<option value="' + d + '">' + d + '</option>');
				  });
				  jQuery("#mmmdt_all_data_table_vaziayat_select option:contains('null')").remove();
				  jQuery('#mmmdt_selectTriggerFilter').prependTo("div#mmmdt_all_data_result_table_wrapper");

				  
				  
				},
				"language": {
					"searchPlaceholder": " جستجو ",
					"lengthMenu": "نمایش _MENU_ رکورد",
					"zeroRecords": " ",
					"info": "نمایش صفحه _PAGE_ از _PAGES_",
					"infoEmpty": "هیچ رکوردی ثبت نشده است",
					"infoFiltered": "(filtered from _MAX_ total records)",
					"search": "",
					"processing": 'در حال بارگزاری <div id="mmmdt_loading_ajax_result_table_inner" style="position: absolute;margin-top: -4px;" class="lds-dual-ring "></div>',
					"print": "چاپ",
					"delete": "حذف",
					"edit": "ویرایش",
					"row": "سطر",
					"altEditor" : {
						"modalClose" : "خروج",
						"edit" : {
							"title" : "ویرایش",
							"button" : "ذخیره"
						},
						"add" : {
							"title" : "افزودن",
							"button" : "افزودن"
						},
						"delete" : {
							"title" : "حذف",
							"button" : "حذف"
						},
						"success" : "موفق",
						"error" : {
							"message" : "خطایی رخ داد",
							"label" : "Errore",
							"responseCode" : "Response code:",
							"required" : "Valore obbligatorio",
							"unique" : "Valore duplicato"
						}
					},
					"paginate": {
						"first": "First",
						"last": "Last",
						"next": "بعدی",
						"previous": "قبلی"
					},
					 select: {
						rows: {
							_: "تعداد %d سطر انتخاب شده",
							0: "",
							1: ""
						},
					},
				},
				 
				buttons: [
					{ extend: 'excel', text: 'خروجی اکسل'},
					"refresh",
				]
			} );
			car_table.on('page.dt', function() {
			  jQuery('html, body').animate({
				scrollTop: jQuery(".dataTables_wrapper").offset().top
			   }, 'slow');
			});
			
			// Apply the search
			car_table.columns().every( function () {
				var that = this;
		 
				$( 'input', this.header() ).on( 'keyup change clear', function () {
					if ( that.search() !== this.value ) {
						that
							.search( this.value )
							.draw();
					}
				} );
			} );
			
			function reset_all_data(){
				car_table.search('').draw();
			}

		} );
		
	})(jQuery);
	 
	
	return;
}
